#####
###  Epoz - a cross-browser-wysiwyg-editor for Zope
##   Copyright (C) 2003 Maik Jablonski (maik.jablonski@uni-bielefeld.de)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
##   along with this program; if not, write to the Free Software
###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#####

from ImageFile import ImageFile

misc_ = {

 # The Epoz-JavaScript-Files
 
'epoz.js':ImageFile('www/epoz.js', globals()),
'epozcolor.html':ImageFile('www/epozcolor.html', globals()),

 # The Epoz-Language-Files
 
'en.js':ImageFile('www/en.js', globals()),
'de.js':ImageFile('www/de.js', globals()),

 # The Epoz-Buttons
 
'button_bold.gif':ImageFile('www/button_bold.gif', globals()),
'button_centre.gif':ImageFile('www/button_centre.gif', globals()),
'button_empty.gif':ImageFile('www/button_empty.gif', globals()),
'button_hr.gif':ImageFile('www/button_hr.gif', globals()),
'button_hyperlink.gif':ImageFile('www/button_hyperlink.gif', globals()),
'button_image.gif':ImageFile('www/button_image.gif', globals()),
'button_indent.gif':ImageFile('www/button_indent.gif', globals()),
'button_italic.gif':ImageFile('www/button_italic.gif', globals()),
'button_left_just.gif':ImageFile('www/button_left_just.gif', globals()),
'button_list.gif':ImageFile('www/button_list.gif', globals()),
'button_numbered_list.gif':ImageFile('www/button_numbered_list.gif', globals()),
'button_outdent.gif':ImageFile('www/button_outdent.gif', globals()),
'button_redo.gif':ImageFile('www/button_redo.gif', globals()),
'button_right_just.gif':ImageFile('www/button_right_just.gif', globals()),
'button_table.gif':ImageFile('www/button_table.gif', globals()),
'button_textcolor.gif':ImageFile('www/button_textcolor.gif', globals()),
'button_tools.gif':ImageFile('www/button_tools.gif', globals()),
'button_underline.gif':ImageFile('www/button_underline.gif', globals()),
'button_undo.gif':ImageFile('www/button_undo.gif', globals()),
}

    
def Epoz(self, name, data='', toolbox='', lang='en', style='width: 600px; height: 250px;', submit=' Save Changes '):
    """ Create an Epoz-Wysiwyg-Editor.
    
        name : the name of the form-element which submits the data        
        data : the data to edit
        toolbox : a link to a HTML-Page which delivers additional tools
        lang: a code for the language-file (en,de,...)
        style : style-definition for the editor
        submit : the label/value of the submit-button
        
        If Epoz can't create a Rich-Text-Editor, 
        a simple textarea is created.
    """

    EpozPath="/misc_/Epoz/";
    
    if data is None:
        data=''
        
    js_data = data

    # Unqoute newlines and single quotes, so the Epoz-JavaScript won't break.
    
    for (key,val) in {'\n':'\\n', '\r':'', "'":"\\'"}.items():
        js_data = js_data.replace(key, val)

    # Return the HTML-Code for the Epoz-Rich-Text-Editor
        
    return """
<iframe id="EpozIFrame" style="position: absolute; visibility: hidden; width: 0px; height: 0px;"></iframe>
<script language="JavaScript" type="text/javascript" src="%s%s.js"></script>
<script language="JavaScript" type="text/javascript" src="%sepoz.js"></script>
<script language="JavaScript" type="text/javascript">
<!--
InitEpoz('%s','%s','%s','%s','%s');
//-->
</script>
<noscript><textarea name="%s" style="%s">%s</textarea></noscript>

<p><input type="submit" name="submit" value="%s" onclick="SubmitEpoz()"></p>
""" % ( EpozPath, lang,
        EpozPath,
        name, js_data, toolbox, style, EpozPath,
        name, style, data,
        submit
      )

# Register Epoz as global method

methods = {'Epoz': Epoz}
