//#####
//###  Epoz - a cross-browser-wysiwyg-editor for Zope
//##   Copyright (C) 2003 Maik Jablonski (maik.jablonski@uni-bielefeld.de)
//#
//#    JavaScript is improved version of http://www.kevinroth.com/rte/demo.htm
//#
//#    This program is free software; you can redistribute it and/or modify
//#    it under the terms of the GNU General Public License as published by
//#    the Free Software Foundation; either version 2 of the License, or
//#    (at your option) any later version.
//#
//#    This program is distributed in the hope that it will be useful,
//#    but WITHOUT ANY WARRANTY; without even the implied warranty of
//#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//#    GNU General Public License for more details.
//#
//#    You should have received a copy of the GNU General Public License
//##   along with this program; if not, write to the Free Software
//###  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//#####

// Just to prevent typos when fetching the Epoz-IFrame...

var Epoz = "EpozEditor";
var EpozColor = "EpozColorPalette";

// Global storages

var form_data;  // the document-data
var form_name;  // the name of the form-element
var form_style; // a css-style-definiton (width,height) for the wysiwyg-area
var form_toolbox; // the path to a toolbox
var form_path; // Path where scripts and images are found

var rng;


// Detect browser type and create Epoz- or Default-Textbox

function InitEpoz(name, data, toolbox, style, path) {

    form_name = name;
    form_data = data; 
    form_toolbox = toolbox;
    form_style = style;
    form_path = path;
        
    if (browser.isIE5up) {
        CreateEpoz();
    }
    else if (browser.isGecko) {

        //check to see if midas is enabled

        var isMidasEnabled = false;

        document.getElementById('EpozIFrame').contentDocument.designMode = "on";
        try {
            document.getElementById('EpozIFrame').contentWindow.document.execCommand("undo", false, null);
            isMidasEnabled = true;
        } catch (e) {
            isMidasEnabled = false;
        }

        if (isMidasEnabled) {
            CreateEpoz();
        } else {
            CreateTextarea();
        }
    }
    else {
        CreateTextarea();
    }
}


// Create HTML for Epoz-Editor

function CreateEpoz() {
    document.writeln('<input type="hidden" id="' + form_name + '" name="' + form_name + '" value="">');
    document.writeln('<table>');
    document.writeln('<tr>');
    document.writeln('<td>');
    document.writeln('<select id="formatblock" onchange="SelectFormat(this.id);">');
    document.writeln('<option value="">'+EpozLangNormal+'</option>');
    document.writeln('<option value="<p>">'+EpozLangParagraph+'</option>');
    document.writeln('<option value="<h1>">'+EpozLangHeading1+'</option>');
    document.writeln('<option value="<h2>">'+EpozLangHeading2+'</option>');
    document.writeln('<option value="<h3>">'+EpozLangHeading3+'</option>');
    document.writeln('<option value="<h4>">'+EpozLangHeading4+'</option>');
    document.writeln('<option value="<h5>">'+EpozLangHeading5+'</option>');
    document.writeln('<option value="<h6>">'+EpozLangHeading6+'</option>');
    document.writeln('<option value="<pre>">'+EpozLangFormatted+'</option>');
    document.writeln('</select>');
    document.writeln('</td>');
    
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_bold.gif" width="25" height="24" alt="'+EpozLangBold+'" title="'+EpozLangBold+'" onClick="FormatText(\'bold\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_italic.gif" width="25" height="24" alt="'+EpozLangItalic+'" title="'+EpozLangItalic+'" onClick="FormatText(\'italic\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_underline.gif" width="25" height="24" alt="'+EpozLangUnderline+'" title="'+EpozLangUnderline+'" onClick="FormatText(\'underline\', \'\');"></td>');
    document.writeln('<td><div id="forecolor"><img style="cursor: pointer;" src="'+form_path+'button_textcolor.gif" width="25" height="24" alt="'+EpozLangTextColor+'" title="'+EpozLangTextColor+'" onClick="SetTextColor();"></div></td>');

    document.writeln('<td>&nbsp;</td>');

    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_left_just.gif" width="25" height="24" alt="'+EpozLangAlignLeft+'" title="'+EpozLangAlignLeft+'" onClick="FormatText(\'justifyleft\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_centre.gif" width="25" height="24" alt="'+EpozLangCenter+'" title="'+EpozLangCenter+'" onClick="FormatText(\'justifycenter\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_right_just.gif" width="25" height="24" alt="'+EpozLangAlignRight+'" title="'+EpozLangAlignRight+'" onClick="FormatText(\'justifyright\', \'\');"></td>');

    document.writeln('<td>&nbsp;</td>');

    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_numbered_list.gif" width="25" height="24" alt="'+EpozLangOrderedList+'" title="'+EpozLangOrderedList+'" onClick="FormatText(\'insertorderedlist\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_list.gif" width="25" height="24" alt="'+EpozLangUnorderedList+'" title="'+EpozLangUnorderedList+'" onClick="FormatText(\'insertunorderedlist\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_outdent.gif" width="25" height="24" alt="'+EpozLangOutdent+'" title="'+EpozLangOutdent+'" onClick="FormatText(\'outdent\', \'\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_indent.gif" width="25" height="24" alt="'+EpozLangIndent+'" title="'+EpozLangIndent+'" onClick="FormatText(\'indent\', \'\');"></td>');

    document.writeln('<td>&nbsp;</td>');

    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_hyperlink.gif" width="25" height="24" alt="'+EpozLangInsertLink+'" title="'+EpozLangInsertLink+'" onClick="CreateLink();"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_image.gif" width="25" height="24" alt="'+EpozLangInsertImage+'" title="'+EpozLangInsertImage+'" onClick="CreateImage();"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_hr.gif" width="25" height="24" alt="'+EpozLangInsertRule+'" title="'+EpozLangInsertRule+'" onClick="FormatText(\'inserthorizontalrule\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_table.gif" width="25" height="24" alt="'+EpozLangInsertTable+'" title="'+EpozLangInsertTable+'" onClick="CreateTable();"></td>');

    if ((form_toolbox != null) && (form_toolbox != "")) {
        document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_tools.gif" width="25" height="24" alt="'+EpozLangToolbox+'" title="'+EpozLangToolbox+'"" onClick="window.open(\''+form_toolbox+'\',\'Toolbox\',\'toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=400,height=400\');"></td>');
    }

    document.writeln('<td>&nbsp;</td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_undo.gif" width="25" height="24" alt="'+EpozLangUndo+'" title="'+EpozLangUndo+'" onClick="FormatText(\'undo\');"></td>');
    document.writeln('<td><img style="cursor: pointer;" src="'+form_path+'button_redo.gif" width="25" height="24" alt="'+EpozLangRedo+'" title="'+EpozLangRedo+'" onClick="FormatText(\'redo\');"></td>');
    document.writeln('</tr>');
    document.writeln('</table>');
    document.writeln('<br />');

    document.writeln('<iframe id="' + Epoz + '" style="' + form_style + '" onload="InitDocument();"></iframe>');
    document.writeln('<iframe width="250" height="170" id="' + EpozColor + '" src="'+form_path+'epozcolor.html" style="visibility:hidden; position: absolute; left: 0px; top: 0px;"></iframe>');
    setTimeout("EnableDesignMode();", 10);
}


// Create a default-textbox for browsers without Rich-Text-Features

function CreateTextarea() {
    document.writeln('<textarea name="' + form_name + '" id="' + Epoz + '" style="' + form_style + '">'+form_data+'</textarea>');
}


// Needs to be called by Timeout for Mozilla... don't know why...

function EnableDesignMode() {
    if (browser.isIE5up) {
        frames[Epoz].document.designMode = "On";
    }
    else {
        document.getElementById(Epoz).contentDocument.designMode = "on";
    }
}


// A submit-wrapper to pass the parameters into the form-element

function SubmitEpoz() {
    try {
        result = document.getElementById(Epoz).contentWindow.document.body.innerHTML;
    } catch (e) {
        result = document.getElementById(Epoz).value;
    }
    document.getElementById(form_name).value = result;
}


// -------------------------------------------------------------
// Here are the definitions for the control-and-format-functions


// Intialize the document

function InitDocument() {
    document.getElementById(Epoz).contentWindow.focus();
    document.getElementById(Epoz).contentWindow.document.body.innerHTML = form_data; 
}


// Format text with RichText-Controls

function FormatText(command, option) {
    document.getElementById(Epoz).contentWindow.focus();
    document.getElementById(Epoz).contentWindow.document.execCommand(command, false, option);
}


// Inserts a piece of html/text at the bottom of the current document

// This needs improvement... Does someone know how to insert HTML at
// current selection for IE & Mozilla? Thank you for the patches...;)

function InsertHTML(html) {
    document.getElementById(Epoz).contentWindow.focus();
    document.getElementById(Epoz).contentWindow.document.body.innerHTML += html;
}


// Create a Hyperlink - IE has its own implementation

function CreateLink(URL) {
    if (browser.isIE5up == false && ((URL == null) || (URL == ""))) {
        URL = prompt(EpozLangEnterLinkURL, "");

        if ((URL != null) && (URL != "")) {
            document.getElementById(Epoz).contentWindow.document.execCommand("CreateLink",false,URL)
        } else {
            document.getElementById(Epoz).contentWindow.document.execCommand("Unlink",false, "")
        }
    } else {
        document.getElementById(Epoz).contentWindow.document.execCommand("CreateLink",false,URL)
    }
}


// Insert image via a URL

function CreateImage(URL) {
    if ((URL == null) || (URL == "")) {
        URL = prompt(EpozLangEnterImageURL, "");
    }
    if ((URL != null) && (URL != "")) {
        document.getElementById(Epoz).contentWindow.focus()
        document.getElementById(Epoz).contentWindow.document.execCommand('InsertImage', false, URL);
    }
}


// Creates a simple table

function CreateTable() {
    rowstext = prompt(EpozLangEnterTableRows, 3);
    colstext = prompt(EpozLangEnterTableColumns, 3);
    border = prompt(EpozLangEnterTableBorder, 1);

    if(window.confirm(EpozLangEnterTableConfirm)) {
       rows = parseInt(rowstext);
       cols = parseInt(colstext);

       if ((rows > 0) && (cols > 0)) {
          table = ' <table border="' + border + '">\n';

          for (var i=0; i < rows; i++) {
             table = table + " <tr>\n";
             for (var j=0; j < cols; j++) {
                table += "  <td>#</td>\n";
             }
             table += " </tr>\n";
          }
          table += " </table>\n";
          InsertHTML(table);
       }
    }
    document.getElementById(Epoz).contentWindow.focus()
}



// Sets color of selected text

function SetTextColor() {
    parent.command = "forecolor";
    buttonElement = document.getElementById("forecolor");
    document.getElementById(EpozColor).style.left = getOffsetLeft(buttonElement) + "px";
    document.getElementById(EpozColor).style.top = (getOffsetTop(buttonElement) + buttonElement.offsetHeight) + "px";

    if (document.getElementById(EpozColor).style.visibility == "hidden")
        document.getElementById(EpozColor).style.visibility="visible";
    else {
        document.getElementById(EpozColor).style.visibility="hidden";
    }

    //get current selected range

    var sel = document.getElementById(Epoz).contentWindow.document.selection; 
    if (sel!=null) {
        rng = sel.createRange();
    }
}


// Sets selected formats

function SelectFormat(selectname)
{
    var cursel = document.getElementById(selectname).selectedIndex;
    // First one is always a label
    if (cursel != 0) {
        var selected = document.getElementById(selectname).options[cursel].value;
        document.getElementById(Epoz).contentWindow.document.execCommand(selectname, false, selected);
        document.getElementById(selectname).selectedIndex = 0;
    }
    document.getElementById(Epoz).contentWindow.focus();
}


// -------------------------------------------
// Some Helper-Functions for the color-palette

function setColor(color) {
    if (browser.isIE5up) {
        //retrieve selected range
        var sel = document.getElementById(Epoz).contentWindow.document.selection; 
        if (sel!=null) {
            var newRng = sel.createRange();
            newRng = rng;
            newRng.select();
        }
    }
    else {
        document.getElementById(Epoz).contentWindow.focus();
    }
    document.getElementById(Epoz).contentWindow.document.execCommand(parent.command, false, color);
    document.getElementById(Epoz).contentWindow.focus();
    document.getElementById(EpozColor).style.visibility="hidden";
}


function getOffsetTop(elm) {
    var mOffsetTop = elm.offsetTop;
    var mOffsetParent = elm.offsetParent;
        
    while(mOffsetParent){
        mOffsetTop += mOffsetParent.offsetTop;
        mOffsetParent = mOffsetParent.offsetParent;
    }
        
    return mOffsetTop;
}


function getOffsetLeft(elm) {
    var mOffsetLeft = elm.offsetLeft;
    var mOffsetParent = elm.offsetParent;
        
    while(mOffsetParent) {
        mOffsetLeft += mOffsetParent.offsetLeft;
        mOffsetParent = mOffsetParent.offsetParent;
    }
        
    return mOffsetLeft;
}


// -----------------------------------------------------------------
// Browser Detect Lite  v2.1.4
// http://www.dithered.com/javascript/browser_detect/index.html
// modified by Chris Nott (chris@NOSPAMdithered.com - remove NOSPAM)

function BrowserDetectLite() {
   var ua = navigator.userAgent.toLowerCase(); 

   // browser name
   this.isGecko     = (ua.indexOf('gecko') != -1 && ua.indexOf('safari') == -1);
   this.isMozilla   = (this.isGecko && ua.indexOf('gecko/') + 14 == ua.length);
   this.isNS        = ( (this.isGecko) ? (ua.indexOf('netscape') != -1) : ( (ua.indexOf('mozilla') != -1) && (ua.indexOf('spoofer') == -1) && (ua.indexOf('compatible') == -1) && (ua.indexOf('opera') == -1) && (ua.indexOf('webtv') == -1) && (ua.indexOf('hotjava') == -1) ) );
   this.isIE        = ( (ua.indexOf('msie') != -1) && (ua.indexOf('opera') == -1) && (ua.indexOf('webtv') == -1) ); 
   this.isSafari    = (ua.indexOf('safari') != - 1);
   this.isOpera     = (ua.indexOf('opera') != -1); 
   this.isKonqueror = (ua.indexOf('konqueror') != -1 && !this.isSafari); 
   this.isIcab      = (ua.indexOf('icab') != -1); 
   this.isAol       = (ua.indexOf('aol') != -1); 
   
   // spoofing and compatible browsers
   this.isIECompatible = ( (ua.indexOf('msie') != -1) && !this.isIE);
   this.isNSCompatible = ( (ua.indexOf('mozilla') != -1) && !this.isNS && !this.isMozilla);
   
   // browser version
   this.versionMinor = parseFloat(navigator.appVersion); 
   
   // correct version number
   if (this.isNS && this.isGecko) {
      this.versionMinor = parseFloat( ua.substring( ua.lastIndexOf('/') + 1 ) );
   }
   else if (this.isIE && this.versionMinor >= 4) {
      this.versionMinor = parseFloat( ua.substring( ua.indexOf('msie ') + 5 ) );
   }
   else if (this.isMozilla) {
      this.versionMinor = parseFloat( ua.substring( ua.indexOf('rv:') + 3 ) );
   }
   else if (this.isSafari) {
      this.versionMinor = parseFloat( ua.substring( ua.lastIndexOf('/') + 1 ) );
   }
   else if (this.isOpera) {
      if (ua.indexOf('opera/') != -1) {
         this.versionMinor = parseFloat( ua.substring( ua.indexOf('opera/') + 6 ) );
      }
      else {
         this.versionMinor = parseFloat( ua.substring( ua.indexOf('opera ') + 6 ) );
      }
   }
   else if (this.isKonqueror) {
      this.versionMinor = parseFloat( ua.substring( ua.indexOf('konqueror/') + 10 ) );
   }
   else if (this.isIcab) {
      if (ua.indexOf('icab/') != -1) {
         this.versionMinor = parseFloat( ua.substring( ua.indexOf('icab/') + 6 ) );
      }
      else {
         this.versionMinor = parseFloat( ua.substring( ua.indexOf('icab ') + 6 ) );
      }
   }
   
   this.versionMajor = parseInt(this.versionMinor); 
   this.geckoVersion = ( (this.isGecko) ? ua.substring( (ua.lastIndexOf('gecko/') + 6), (ua.lastIndexOf('gecko/') + 14) ) : -1 );
   
   // dom support
   this.isDOM1 = (document.getElementById);
   this.isDOM2Event = (document.addEventListener && document.removeEventListener);
   
   // css compatibility mode
   this.mode = document.compatMode ? document.compatMode : 'BackCompat';

   // platform
   this.isWin   = (ua.indexOf('win') != -1);
   this.isWin32 = (this.isWin && ( ua.indexOf('95') != -1 || ua.indexOf('98') != -1 || ua.indexOf('nt') != -1 || ua.indexOf('win32') != -1 || ua.indexOf('32bit') != -1 || ua.indexOf('xp') != -1) );
   this.isMac   = (ua.indexOf('mac') != -1);
   this.isUnix  = (ua.indexOf('unix') != -1 || ua.indexOf('sunos') != -1 || ua.indexOf('bsd') != -1 || ua.indexOf('x11') != -1)
   this.isLinux = (ua.indexOf('linux') != -1);
   
   // specific browser shortcuts
   this.isNS4x = (this.isNS && this.versionMajor == 4);
   this.isNS40x = (this.isNS4x && this.versionMinor < 4.5);
   this.isNS47x = (this.isNS4x && this.versionMinor >= 4.7);
   this.isNS4up = (this.isNS && this.versionMinor >= 4);
   this.isNS6x = (this.isNS && this.versionMajor == 6);
   this.isNS6up = (this.isNS && this.versionMajor >= 6);
   this.isNS7x = (this.isNS && this.versionMajor == 7);
   this.isNS7up = (this.isNS && this.versionMajor >= 7);
   
   this.isIE4x = (this.isIE && this.versionMajor == 4);
   this.isIE4up = (this.isIE && this.versionMajor >= 4);
   this.isIE5x = (this.isIE && this.versionMajor == 5);
   this.isIE55 = (this.isIE && this.versionMinor == 5.5);
   this.isIE5up = (this.isIE && this.versionMajor >= 5);
   this.isIE6x = (this.isIE && this.versionMajor == 6);
   this.isIE6up = (this.isIE && this.versionMajor >= 6);
   
   this.isIE4xMac = (this.isIE4x && this.isMac);
}
var browser = new BrowserDetectLite();
